<template>
  <v-container>
    <v-row justify="space-between">
      <v-col cols="5">
        <v-select
          v-model="actions.tappingIncrement"
          :label="$t('tap-bar.label.increment')"
          :items="possibleIncrements"
          :item-text="(item) => $t(`tap-bar.${item.text}`)"
        />
      </v-col>
      <v-col cols="6">
        <v-row>
          <!-- The countdown bar -->
          <countdown
            v-model="isCountdownSync"
            :duration="2"
            @finished="startTapping"
          />
          <dez-fab
            ref="tapButton"
            icon="mdi-hand-clap"
            color="warning"
            :disabled="isCountdownSync"
            :tooltip="$t(isTappingSync ? 'tap-bar.tooltip.tap' : 'tap-bar.tooltip.start')"
            chip="␣"
            @click="() => isTappingSync ? tap() : startCountdown()"
          />
          <dez-fab
            icon="mdi-stop"
            :disabled="!isCountdownSync && !isTappingSync"
            :tooltip="$t('tap-bar.tooltip.stop')"
            @click="stop"
          />
        </v-row>
        <v-row>
          <dez-fab
            :key="actions.selectCount"
            class="ma-5"
            color="warning"
            icon="mdi-undo"
            :tooltip="$t('tap-bar.tooltip.retry')"
            :disabled="!isTappingSync"
            chip="r"
            @click="() => retry()"
          />
          <dez-fab
            :key="actions.selectCount"
            class="ma-5"
            color="warning"
            icon="mdi-minus"
            :tooltip="$t('tap-bar.tooltip.delete')"
            :disabled="!isTappingSync"
            chip="d"
            @click="() => del()"
          />
          <dez-fab
            :key="actions.selectCount"
            class="ma-5"
            color="warning"
            icon="mdi-redo"
            :tooltip="$t('tap-bar.tooltip.skip')"
            :disabled="!isTappingSync"
            chip="i"
            @click="() => skip()"
          />
        </v-row>
      </v-col>
      <v-col cols="1" class="d-flex">
        <dez-fab
          :key="actions.selectCount"
          class="ma-5"
          color="warning"
          icon="mdi-delete"
          :tooltip="$t('sync-bar.tooltip.delete')"
          :disabled="!state || !state.canDelete || isTappingSync"
          @click="() => actions.deleteSelected(true, true)"
        />
      </v-col>
    </v-row>
  </v-container>
</template>

<script lang="ts">
import {
  Vue, Component, Prop, PropSync, Watch,
} from 'vue-property-decorator';
import type {
  Onset, Second, Signature, SyncPoint,
} from '@/data';
import type SynchronizationActions from '@/synchronization-logic/SynchronizationActions';
import DezFab from '@/vuejs/components/utils/DezFab.vue';
import Countdown from './Countdown.vue';
import type { State } from './SyncBar.vue';

export interface Increment {
  value: number | (() => number);
  text: string;
}

@Component({
  components: { Countdown, DezFab },
})
export default class TapBar extends Vue {
  @Prop({ required: true })
  actions!: SynchronizationActions;

  @Prop({ required: true })
  signature!: Signature;

  @Prop({ required: true })
  realTime!: Second | null;

  @PropSync('isTapping', { required: true })
  isTappingSync!: boolean;

  @PropSync('isCountdown', { required: true })
  isCountdownSync!: boolean;

  @PropSync('playing', { required: true })
  playingSync!: boolean;

  @Prop({ required: true })
  setTime!: (onset: Onset) => void;

  skipIncr = 1;

  state: State | null = null;

  mounted() {
    // Add event listeners
    document.addEventListener('keydown', this.onKey);
  }

  beforeDestroy() {
    // if countdown or tap started, abort
    this.stop();
    // Remove event listeners
    document.removeEventListener('keydown', this.onKey);
  }

  // Keyboard shortcuts
  // On space, add a new sync point
  // On escape, stop tapping
  onKey(e: KeyboardEvent) {
    // If not currently tapping, ignore any event
    if (!this.isTappingSync) return;

    if (e.key === ' ') {
      this.tap();
      e.preventDefault();
    } else if (e.key === 'Escape') {
      this.stop();
      e.preventDefault();
    } else if (e.key === 'i') {
      this.skip();
      e.preventDefault();
    } else if (e.key === 'd' || e.key === 'Delete') {
      this.del();
      e.preventDefault();
    } else if (e.key === 'r') {
      this.retry();
      e.preventDefault();
    }
  }

  @Watch('actions.selectCount')
  @Watch('actions.editCount')
  updatedSelected() {
    const label = this.actions.getSelected();

    // If a label is selected
    if (label) {
      // Create a copy of the label sync point
      const point = [...label.point] as SyncPoint;
      const { id } = label;
      // Forbid deleting the first and last sync point
      const canDelete = !!(this.actions.getPrev(id) && this.actions.getNext(id));
      // Init the state
      this.state = { point, id, canDelete };
    } else {
      this.state = null;
    }
  }

  // Tapping handling

  setTimeToSelection() {
    // Try to ensure selection
    const selected = this.actions.getSelectedOrFirst();
    this.actions.select(selected.id);

    // Set the time to the selected sync point
    this.setTime(selected.onset);
  }

  startCountdown() {
    // Start the countdown, an event will be received from <countdown> to start tapping
    this.isCountdownSync = true;
    this.playingSync = false;
    this.setTimeToSelection();
  }

  startTapping() {
    // Set tapping to true
    this.isTappingSync = true;
    // Make sure the music time is at the correct position
    this.setTimeToSelection();
    // Start play
    this.playingSync = true;
  }

  tap() {
    // If playback stopped for any reason, stop
    if (!this.realTime) {
      this.stop();
      return;
    }
    // Try to create a new sync point
    const label = this.actions.createTappingSyncPoint(this.realTime, this.skipIncr);
    this.skipIncr = 1;
    this.$emit('skip', this.skipIncr);

    // If impossible to create a label, stop
    // TODO: explain why to the user
    if (!label) this.stop();
  }

  stop() {
    // If currently tapping and playing, stop the music
    if (this.isTappingSync) this.playingSync = false;

    this.isCountdownSync = false;
    this.isTappingSync = false;
  }

  skip() {
    this.skipIncr += 1;
    this.$emit('skip', this.skipIncr);
  }

  del() {
    const current = this.actions.getSelected();
    if (current) {
      const prev = this.actions.getPrev(current.id);
      if (prev) {
        this.actions.select(prev.id);
        this.actions.deleteId(current.id);
        this.skip();
      }
    }
  }

  retry() {
    const current = this.actions.getSelected();
    if (current) {
      const prev = this.actions.getPrev(current.id);
      if (prev) {
        const prevPrev = this.actions.getPrev(prev.id);
        if (prevPrev) {
          this.actions.select(prev.id);
          this.actions.deleteId(current.id);
          this.setTime(prevPrev.onset);
        }
      }
    }
  }

  // Increments handling

  @Prop()
  possibleIncrements!: Increment[];
}
</script>
